﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
// سودوکو با آ استار  ___ واعظی
namespace SudokuSolve
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // توجه : کدهای مربوط به حل سودوکو در فایل زیر قرار دارند
        //Sudoku.cs  : این فایل

        private void Form1_Load(object sender, EventArgs e)
        {
            // نمایش زمان شروع
            string Time = DateTime.Now.Minute.ToString()+ "   " + DateTime.Now.Second.ToString() + "  " + DateTime.Now.Millisecond.ToString();
            lblTimeStart.Text += Time;

            // Sudoku ایجاد یک شی از کلاس 
            Sudoku SUdok = new Sudoku();
            //ایجاد جدول 9*9
            string[] SolvedSudoku = new string[81];
            //سودوکوی کامل  
            string  temp1 = "219876435843591276765243891394157628127368954658429317482735169536914782971682543";
            // قرار دادن سودوکوی کامل در جدول
            for (int i = 0; i < 81; i++)
            {
                SolvedSudoku[i] = Convert.ToString(temp1[i]);
            }
            SUdok.Fill(SolvedSudoku);
            // نمایش سودوکوی کامل
            lblCompleteSudoko.Text = SUdok.Show();





            // خالی کردن جدول برای حل سودوکو
            for (int i = 0; i < 81; i++)
            {
                SolvedSudoku[i] = "0";
            }

           //سودوکوی ورودی ،  ناقص
            //مقدار  صفر در رشته ی ورودی بیانگر نقاط خالی در جدول می باشد.
            string temp = "219876435803591276065243891394150628127368954658429307482735169536914702970682543";
            // قرار دادن سودوکوی ورودی در جدول
            for (int i = 0; i < 81; i++)
            {
                SolvedSudoku[i] = Convert.ToString(temp[i]);
            }

            SUdok.Fill(SolvedSudoku);
            //حل سودوکو
            SUdok.SolvedSudoku();
            //نمایش نتیجه
            lblissolution2.Text = Convert.ToString(SUdok.isSolution());
            lblOutput2.Text = SUdok.Show();

            
            // نمایش زمان پایان
            Time = string.Empty;
            Time = DateTime.Now.Minute.ToString() + "   " + DateTime.Now.Second.ToString() + "   " + DateTime.Now.Millisecond.ToString();
            lblTimeEnd.Text += Time;
        }




        // این تابع زیاد مهم نیست و فقط جهت نمایش پیغام پایین صفحه است
        private void timer1_Tick(object sender, EventArgs e)
        {
            Random rnd = new Random();
            int r, g, b;
            r = rnd.Next(0, 255);
            g = rnd.Next(0, 255);
            b = rnd.Next(0, 255);
            label2.BackColor = Color.FromArgb(r, g, b);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://WWw.SourceCodes.ir");

        }
    }
}
